
init 998 python:
    def _toggle_quick_menu_q():

        if renpy.has_screen('quick_menu'):
            if not hasattr(store, 'quick_menu'):
                setattr(store, 'quick_menu', True)
                renpy.show_screen('quick_menu')
                setattr(store, 'suppress_overlay', False)
            else:
                if quick_menu == True:
                    setattr(store, 'quick_menu', False)
                    renpy.hide_screen('quick_menu')
                else:
                    setattr(store, 'quick_menu', True)
                    renpy.show_screen('quick_menu')
                    setattr(store, 'suppress_overlay', False)

    config.keymap[ 'toggle_quick_menu_q' ] = [ 'K_q' ]
    config.underlay.append(renpy.Keymap(toggle_quick_menu_q = Function(_toggle_quick_menu_q)))


init -500 screen navigation():

    vbox:
        style_prefix "navigation"

        xpos gui.navigation_xpos
        yalign 0.5

        spacing gui.navigation_spacing

        if main_menu:

            textbutton _("Start") action Start()

        else:

            textbutton _("History") action ShowMenu("history")

            textbutton _("Save") action ShowMenu("save")

        textbutton _("Load") action ShowMenu("load")

        textbutton _("Preferences") action ShowMenu("preferences")

        if not _in_replay:
            textbutton _("Scene Replay") action [ui.callsinnewcontext("galleryNameChange"), ShowMenu("sceneReplay1")] text_style "shaddyTextButton2"

        if _in_replay:

            textbutton _("End Replay") action EndReplay(confirm=True)

        elif not main_menu:

            textbutton _("Main Menu") action MainMenu()

        #textbutton _("About") action ShowMenu("about")

        if renpy.variant("pc"):


            #textbutton _("Help") action ShowMenu("help")


            textbutton _("Quit") action Quit(confirm=not main_menu)


init -500 screen main_menu():
    ## This ensures that any other menu screen is replaced.
    tag menu

    #add Movie(size=(1920, 1080))
    #on "show" action Play("movie", "images/screen.webm", loop=True)
    #on "hide" action Stop("movie")
    #on "replace" action Play("movie", "images/screen.webm", loop=True)
    #on "replaced" action Stop("movie")

    style_prefix "main_menu"

    #add gui.main_menu_background

    ## This empty frame darkens the main menu.
    frame:
        pass

    ## The use statement includes another screen inside this one. The actual
    ## contents of the main menu are in the navigation screen.
    #use navigation

    hbox:
        style_prefix "navigation"


        yalign .95
        xalign .5

        spacing gui.navigation_spacing

        imagebutton idle "gui/button/new_game_idle.png" hover "gui/button/new_game_hover.png"  action Start()

        imagebutton idle "gui/button/load_idle.png" hover "gui/button/load_hover.png"  action ShowMenu("load")

        imagebutton idle "gui/button/settings_idle.png" hover "gui/button/settings_hover.png"  action ShowMenu("preferences")


        if renpy.variant("pc"):

            ## The quit button is banned on iOS and unnecessary on Android and
            ## Web.
            imagebutton idle "gui/button/quit_idle.png" hover "gui/button/quit_hover.png"  action Quit(confirm=not main_menu)

    if not _in_replay:
        textbutton _("Shaddy's Scene Replay") action [ui.callsinnewcontext("galleryNameChange"), ShowMenu("sceneReplay1")] align(0.5,0.85) text_style "shaddyTextButton3"

    if gui.show_name:

        vbox:
            yalign 0.1

            text "[config.name!t]":
                style "main_menu_title"
                outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]

            text "v [config.version]":
                style "main_menu_version"
                outlines [ (absolute(2), "#000", absolute(1), absolute(1)) ]



    imagebutton idle "gui/patreon.png" hover "gui/patreon_hover.png" xpos 128 ypos 128 xanchor 0.5 yanchor 0.5 action OpenURL("https://www.patreon.com/maksgame")
    imagebutton idle "gui/discord.png" hover "gui/discord_hover.png" xpos 128 ypos 278 xanchor 0.5 yanchor 0.5 action OpenURL("https://discord.com/invite/JPVX2um8Mf")
    #imagebutton idle "gui/discord.png" hover "gui/discord_hover.png" xpos 128 ypos 428 xanchor 0.5 yanchor 0.5  action OpenURL("https://www.patreon.com/maksgame")


init -500 screen preferences():
    tag menu
    use game_menu(_("Preferences"), scroll="viewport"):
        vbox:
            hbox:
                box_wrap True

                if renpy.variant("pc") or renpy.variant("web"):
                    vbox:
                        style_prefix "radio"
                        label _("Display")
                        textbutton _("Window") action Preference("display", "window")
                        textbutton _("Fullscreen") action Preference("display", "fullscreen")

                vbox:
                    style_prefix "radio"
                    label _("Rollback Side")
                    textbutton _("Disable") action Preference("rollback side", "disable")
                    textbutton _("Left") action Preference("rollback side", "left")
                    textbutton _("Right") action Preference("rollback side", "right")

                vbox:
                    style_prefix "check"
                    label _("Skip")
                    textbutton _("Unseen Text") action Preference("skip", "toggle")
                    textbutton _("After Choices") action Preference("after choices", "toggle")
                    textbutton _("Transitions") action InvertSelected(Preference("transitions", "toggle"))
                vbox:
                    style_prefix "check"
                    label _("Quick Menu")
                    textbutton _("Enabled") action ToggleVariable("quick_menu", true_value=True, false_value=False)

            null height (4 * gui.pref_spacing)

            hbox:
                style_prefix "slider"
                box_wrap True
                vbox:
                    label _("Text Speed")
                    bar value Preference("text speed")

                    label _("Auto-Forward Time")
                    bar value Preference("auto-forward time")
                vbox:
                    if config.has_music:
                        label _("Music Volume")
                        hbox:
                            bar value Preference("music volume")

                    if config.has_sound:
                        label _("Sound Volume")
                        hbox:
                            bar value Preference("sound volume")

                            if config.sample_sound:
                                textbutton _("Test") action Play("sound", config.sample_sound)

                    if config.has_voice:
                        label _("Voice Volume")
                        hbox:
                            bar value Preference("voice volume")
                            if config.sample_voice:
                                textbutton _("Test") action Play("voice", config.sample_voice)

                    if config.has_music or config.has_sound or config.has_voice:
                        null height gui.pref_spacing

                        textbutton _("Mute All"):
                            action Preference("all mute", "toggle")
                            style "mute_all_button"


init -500 screen file_slots(title):

    default page_name_value = FilePageNameInputValue(pattern=_("Page {}"), auto=_("Automatic saves"), quick=_("Quick saves"))

    use game_menu(title):

        fixed:

            ## This ensures the input will get the enter event before any of the
            ## buttons do.
            order_reverse True

            ## The page name, which can be edited by clicking on a button.
            button:
                style "page_label"

                key_events True
                xalign 0.5
                action page_name_value.Toggle()

                input:
                    style "page_label_text"
                    value page_name_value

            ## The grid of file slots.
            grid gui.file_slot_cols gui.file_slot_rows:
                style_prefix "slot"

                xalign 0.5
                yalign 0.5

                spacing gui.slot_spacing

                for i in range(gui.file_slot_cols * gui.file_slot_rows):

                    $ slot = i + 1

                    button:
                        action FileAction(slot)

                        has vbox

                        add FileScreenshot(slot) xalign 0.5

                        text FileTime(slot, format=_("{#file_time}%A, %B %d %Y, %H:%M"), empty=_("empty slot")):
                            style "slot_time_text"

                        text FileSaveName(slot):
                            style "slot_name_text"

                        key "save_delete" action FileDelete(slot)

            if not renpy.variant("mobile"):
                if title == "Save":
                    hbox:
                        style_prefix "page"
                        pos(85, 70)

                        text "Save name: "
                        input:
                            pos(5, 2)
                            size 30
                            default "[save_name]"
                            value VariableInputValue("save_name")
                            length 30

            ## Buttons to access other pages.
            hbox:
                style_prefix "page"

                xalign 0.5
                yalign 1.0

                spacing gui.page_spacing

                textbutton _("prev") action FilePagePrevious()

                if config.has_autosave:
                    textbutton _("{#auto_page}A") action FilePage("auto")

                if config.has_quicksave:
                    textbutton _("{#quick_page}Q") action FilePage("quick")

                ## range(1, 10) gives the numbers from 1 to 9.
                for page in range(1, 10):
                    textbutton "[page]" action FilePage(page)

                textbutton _("next") action FilePageNext()
